#!/usr/bin/perl 
#==========================================
#  Teremok, CGI installer and CMS                                                     
#Copyright (C) 2004 Kinyev Aleksey, SkifNET Company
#==========================================                                     
#  This program is free software; you can redistribute it and/or                    
#modify it under the terms of the GNU General Public License as 
#published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#  This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#  You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
#===================================================
#  "",  CGI   -
#Copyright (C) 2004  ,   SkifNET (Atey.RU)
#===================================================
#       . 
#    /     
#  2           
#  GNU,  Free Software Foundation. 
#         ,     , 
#      ,      
#         . 
#           
# GNU.
#           
#  GNU.     ,     
#Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 

undef $|;
                
use CGI::Carp qw (fatalsToBrowser);          #    browser- 
require ('terem.conf');
require ('modules/fileman.pl');
require ('modules/mycgi.pl');
require ('modules/common.pl');

#   
# : 
# %params, $action, $programm, $category, $prog_fullname, $prog_review, $prog_license
# $defpath, $html_dir, $cgi_dir

&read_db;
&setparams;


# !!!!!!
#====================

if ($action =~ /download/) {
   &download; exit;
}

if ($action =~ /install/) {
   push @subst, 'pagetitle', ' ';   
   &hthead;
   chdir($incdir); &file2out('head.html',@subst);
   &form2;
   &form1;
   chdir($incdir); &file2out('tail.html',@subst);       
}
elsif ($action =~ /submit/) {
   push @subst, 'pagetitle', ' ';   
   &hthead;
   chdir($incdir); &file2out('head.html',@subst);
   &install;
   chdir($incdir); &file2out('tail.html',@subst);       
}
elsif ($action =~ /fman/) {
   &hthead;
   push @subst, 'pagetitle', ' ';   
   chdir($incdir); &file2out('head.html',@subst);
   &filemanager;
   chdir($incdir); &file2out('tail.html',@subst);    
}
else {
   push @subst, 'pagetitle', ' ';   
   &hthead;
   chdir($incdir); &file2out('head.html',@subst);
   &form1;
   chdir($incdir); &file2out('tail.html',@subst);    
}
  
# 


#  
#========================

sub install {

#!
  mkdir ($tmpdir,0755);
  if (!-d $tmpdir) { mkdir ($tmpdir,0755)};
  if (!-d "$tmpdir/$programm") { mkdir ("$tmpdir/$programm",0755) };
  $pwd .= "$tmpdir/$programm";  
  chdir ($pwd);

  my $error; my $titl; my $mess;
  if (-e $lockfile) {$error = "          ($lockfile)"; &result ($error,$script,"");}
  else { &mylock ($lockfile);} #   !:)
     
  print "<h3> ".$prog_fullname."</h3>"; 

  $prog_arch =~ /(\w+)$/;
  $arch_type = $1;

    &wgetcall ($prog_archurl); #  
    &unarch ($prog_arch); #  
    &instarch; #    
    
#   
    my $mesfile=$html_root."/".$html_dir."/notes.html";
    $titl = ""; $mess = "";
    if (open (MSG,"<$mesfile")) {while (<MSG>) { $mess .= $_ }}
    else { $mess = "    "; }
    &resultxt ($titl, $mess);
    &resultxt ( qq~     - , ,   : <a href="mailto:teremok\@skifnet.com">teremok\@skifnet.com</a>~);
    &myunlock ($lockfile); # !!
}

#    
sub setparams {
  
  %params = &extrenv;

  if ($params{'action'}) {$action = $params{'action'};}
  
  if ($params{'defaultpath'}) {$defpath = $params{'defaultpath'};}
  if ($params{'programm'} =~ /ARRAY(.+)/) {
      foreach (@{$params{'programm'}}) {
        if ($_ =~ /^(\w+)\@\@(\w+)/) { $programm = $1; $category = $2;}
      }    
  }
  else {$params{'programm'} =~ /^(\w+)\@\@(\w+)/; $programm = $1; $category = $2;}

  if ($params{'htmldir'}) {$html_dir=$params{'htmldir'};}
  if ($params{'cgidir'}) {$cgi_dir=$params{'cgidir'};}
  
  if ($programm ne "") {
  
#   
    if ($cgi_dir =~ /\*/ || $cgi_dir =~ /^\s*\./ || $defpath eq "yes") { $cgi_dir=$programm}
    if ($html_dir =~ /\*/ || $cgi_dir =~ /^\s*\./ || $defpath eq "yes"){ $html_dir=$programm}


#,    progs.db  !
    if (${$progs{$programm}}{'cgidir'} ne "") {$cgi_dir=${$progs{$programm}}{'cgidir'}}
    if (${$progs{$programm}}{'htmldir'} ne "") {$html_dir=${$progs{$programm}}{'htmldir'}}
    
    #   
    $prog_archsite=$htport.$arch_site;

    #  
    $prog_archurl=${$progs{$programm}}{'download'};

    #  
    $prog_archurl =~ m/\/([\.\w\-]+)$/;
    $prog_arch=$1;

    #  
    $prog_fullname=${$progs{$programm}}{'fullname'};

    #  
    $prog_installer=${$progs{$programm}}{'installer'};
        
    #
    $prog_license=${$progs{$programm}}{'license'};

    #
    $prog_manual=${$progs{$programm}}{'manual'};
    if ($prog_manual !~ /http/) { $prog_manual="http://$site_root/$html_dir/$prog_manual"; $prog_manual =~ s/(\w)\/{2,}/\1\//g; }

    #   
    $prog_review=${$progs{$programm}}{'review'};

    # cgi-  
    $arch_cgi=${$progs{$programm}}{'archcgi'};

    # html-  
    $arch_html=${$progs{$programm}}{'archhtml'};

    #/cgi-bin/  /
    $prog_cgi=${$progs{$programm}}{'cgi'};
    if ($prog_cgi eq "") {$prog_cgi="/";}

    #    
    if ($prog_archurl !~ /http/) { $prog_archurl="$prog_archsite/$prog_arch"; }

    if ($prog_license ne "") { 

    $prog_license = qq~
    <br>      <a href=$prog_license target=_blank> </a> <br> ,     .   ,     .<br><br>
~;
    }
 }
 
  @subst = ("cgi_root", $cgi_site_root, "html_root", $site_root, "script", $script);        

}

#============================================
#     
sub instarch () {

  if ($arch_html eq "")  {$arch_html="httpdocs";}
  if ($arch_cgi eq "")   { $arch_cgi="cgi-bin";}
  
  $pwd="$tmpdir/$programm"; chdir ($pwd);

  my $cgi_dest = $cgi_root."/".$cgi_dir;
  my $html_dest = $html_root."/".$html_dir;
  my $installer = "http://".$site_root.$prog_cgi.$html_dir."/".$prog_installer;    
  my $old;
  
  $installer =~ s/(\w)\/{2,}/\1\//g;

  $titl=" "; $mess="";

  if (-d $arch_cgi) {
    $pwd=$arch_cgi; chdir ($pwd);
    if (&correct) { $mess .= "  ,   - <br>"; }
    else {$mess .= "  ,   -  ! ,    <br>";}
    $pwd="$tmpdir/$programm"; chdir ($pwd)    
  }  
  

  if ($prog_cgi =~ "/cgi-bin/") {
       $installer = "http://".$cgi_site_root."/".$cgi_dir."/".$prog_installer;
       $installer =~ s/(\w)\/{2,}/\1\//g;  
       if ($cgi_dir ne "") {
          if (-e $cgi_dest) {
            $old = $cgi_dest.".back"; if (-e $old) {`rm -r $old` }; `mv $cgi_dest $old`;
            $mess .= " <b>$cgi_dest</b> ,   .     <b>".$old."</b><br>\n";
          }
          mkdir ($cgi_dest,0755); if (!-e $cgi_dest) { &terminate("   CGI ", $lockfile)};

       }

      chdir ($arch_cgi) or &terminate("   CGI ", $lockfile); `cp -r * $cgi_dest`; chdir ($pwd);
      $mess .= " - CGI-  : <b>$cgi_dest</b><br>";
      if ($own ne "") {chdir ($cgi_dest); `chown -R $own *` ; chdir ($pwd);}
      if ($own_grp ne "") {chdir ($cgi_dest);`chgrp -R $own_grp *` ; chdir ($pwd);}
  }
                                                                                                                                                             
  if ($html_dir ne "") {
     if (-e $html_dest) {
        $old = $html_dest.".back"; if (-e $old) {`rm -r $old`}; `mv $html_dest $old`; 
        $mess .= " <b>$html_dest</b> ,   .     <b>".$old."</b><br>\n";
     }
     mkdir ($html_dest,0755); if (!-e $html_dest) {&terminate("   HTML ", $lockfile)};

  }

  chdir ("$arch_html") or &terminate("   HTML ", $lockfile); `cp -r * $html_dest`; chdir ($pwd);
  $mess .= " - HTML-  : <b>$html_dest</b><br>";
  if ($own ne "") {chdir ($html_dest); `chown -R $own *` ; chdir ($pwd);}
  if ($own_grp ne "") {chdir ($html_dest);`chgrp -R $own_grp *` ; chdir ($pwd);}

    &resultxt ($titl, $mess);
  
    $titl = " ".$prog_fullname." ";
    $mess = qq~      <a href="$installer" target="_blank"></a><br>
      <a href="$prog_manual" target="_blank">  .</a><br>
~;
    &resultxt ($titl, $mess);    
 
}

#==============  ====================
sub form1 {
  my $select =  qq~  <table border="0">  ~;

#========================================
# %categs -   !:)
#  -   ,  - 
# 0   -  ,  -   
# !! ,  ,    %))
#========================================

foreach $currentcat (keys %categs) {
  my @k=@{$categs{$currentcat}};
  $select .=  qq~<tr>
<form action="<%script%>" method="GET"><input type="hidden" name="defaultpath" value="yes"><input type="hidden" size="20" name="action" value="install">
<td><b> @k[0] </b></td><td align="right"><select name="programm">~;

  my $st1=qq~------------------------------------------- -------------------------------------------~;
  my $lnth = length($st1);
  my $tocat = int(0.5*($lnth - 50));
  $st1 =~ s/^.{$tocat}//;
  $st1 =~ s/.{$tocat}$//;
  
  ${$progs{'FAKE_LIST_ITEM'}}{'fullname'} = $st1;
  @k[0] = "FAKE_LIST_ITEM";
  
  foreach (@k) {
     $select .= qq~ <option length="80" value="$_\@\@$currentcat"> ${$progs{$_}}{'fullname'} ~;
  }
  $select .=  qq~</select></td><td><input class="submit" type="submit" value="">
</td></form></tr>
~;
 
}

  $select .=  "</table>";

  push @subst, 'programs', $select;
  chdir ($incdir);
  file2out ("form.html", @subst);
  pop @subst; pop @subst;
}
#============== -   ==================


#==============   ====================
sub form2 {

   my $warning =""; my $old = ""; my $error = "";
   chdir ($tmpdir);
   my $cgi_dest = $cgi_root."/".$cgi_dir;
   my $html_dest = $html_root."/".$html_dir;

   if (open(F, $cgi_dest) && $cgi_dir ne "") {
     $old = $cgi_dest.".back";
     $warning .= "<br><b><font color=#990000>!!</font></b>    <br><i>".$cgi_dest ." </i><b></b>,<br>     <br><i>".$old."</i><br></b>";
     close F;
   }
   if (open(F, $html_dest) && $html_dir ne "") {
     $old = $html_dest.".back";
     $warning .= "<br><b><font color=#990000>!!</font></b>    <br><i>".$html_dest ." </i><b></b>,<br>     <br><i>".$old."</i><br></b>";
     close F;
   }
   
   if ($programm =~ /\w+/ && $programm ne "FAKE_LIST_ITEM") {
      print<<EOM;
<table cellpadding="0" cellspacing="0" class="info" align="center">
<tr><td class="menu0">
&nbsp&nbsp&nbsp<b>  &quot<a class="menu0" href=$prog_review target=_blank>$prog_fullname</a>&quot</b></td></tr>
<tr><td class="info">
$prog_license
&nbsp&nbsp&nbsp&nbsp<u><b>:</b></u><ul>
<form action=$script method="get">   
<li><b>HTML:</b> $html_root/<input type="text" name="htmldir" value=$html_dir></li>
<li><b>CGI:</b> $cgi_root/<input type="text" name="cgidir" value=$cgi_dir> </li>
<li>  - <input type="checkbox" name="defaultpath" value="yes"> </li>
</ul>
 $warning <br>
 <input type=hidden name="programm" value=$programm\@\@$category>
 <input type=hidden name="action" value="submit">
 &nbsp&nbsp&nbsp<input class="submit" type="submit" value="  >>">
 <input type="submit" class="submit" value="" onClick="location.href='$script'; return false;">
 </form>
 <table cellpadding="0" cellspacing="0" height="10"><tr><td></td></tr></table>   
 </td></tr></table>
 <table cellpadding="0" cellspacing="0" height="10"><tr><td></td></tr></table>
EOM
   }
   else { $error = "     ! ,      !";
     if ($error ne 0) {&result ($error,$script,qq~"$script"~)}
   }

}
#============== -    ==================


#=============     =============
sub read_db {
  my ($error, $st, @str, $currentcat, $programm);
  
  #  
  open (F,"< $progsdb") or $error = "     ",$progsdb,"!";
  if ($error ne "") {&result ($error,"","")}

  #,    
  my $comment=0;

  #,    
  my $unclosed=0;

  #  
  my $i=0;
  

 while (<F>) {
  $st=$_;
#  chomp ($st);
  $st =~ s/^[\s]+//;
  $st =~ s/[\s]+$//;
  $i++;
  if ($st =~ m/<!--/) {$comment++;} # !
  if ($st =~ m/^\#/) {$comment++;}  


#  
#!/usr/bin/perl 
  if ($comment==0) { 

# 
    if ($st =~ m/^%/) {
       @str=split /::/,$st;
       @str[0] =~ /^%(.+)/;
       $currentcat = $1;
       push @{$categs{$currentcat}},@str[1]; # - ,  - 
    }

#  
    if ($st =~ m/^\s*(\w+)/ && $unclosed == 0) {
      $programm=$1;
      if ($st =~ m/\:\:(.+)$/) { $progopt{'fullname'} = $1;}
      push @{$categs{$currentcat}}, $programm;
      if ($st =~ m/\{/) {
          if ($unclosed ne 0) {$error="   (2) -     ".$i." = ".$_;
                print "<h3>".$error."</h3>"; &terminate ($error) }
          else {$unclosed==1;}
      } 
    }
#  ,        
   if ($st =~ m/^\s*\{/) {
      if ($unclosed ne 0) {$error="   (1) -     ".$i." = " .$_;
           &terminate ($error)  }
        else {$unclosed=1;}
   }
    
# -
    if ($st =~ /(arch|archcgi|archhtml|cgi|cgidir|download|fullname|htmldir|installer|license|manual|review)/) {
          @str=split /::/,$st;
          $progopt{@str[0]} = @str[1];
    }

#  
   if ($st =~ /\}/) {
      if ($unclosed eq 0) {$error="    -      ".$i;
                &terminate ($error)  }
      %{$progs{$programm}} = %progopt;
      undef %progopt;
      $unclosed=0;
      $programm="";
   }
  }
#   

  if ($st =~ m/-->/ && $comment > 0) {$comment--}  # 
  if ($st =~ m/^\#/) {$comment--;}  

}
close F;
}
#============= -      =============

